<template>
  <div class="flex flex-col items-start h-full pl-4 pr-1 lg:pt-0 pt-20">
    <div class="flex items-center mb-4">
      <h2 class="max-w-none">Suchergebnis</h2>
      <div
        v-if="total > 0"
        effect="plain"
        class="bg-transparent ml-3 h-8 border-primary-400 text-primary-500 text-xs p-2 border-2 rounded leading-loose flex justify-center items-center"
      >{{total}} Treffer</div>
    </div>
    <div class="flex flex-col flex-1 overflow-x-hidden w-full overflow-y-scroll scrolling-touch">
      <Card
        v-for="monastery in monasteries"
        :key="monastery.gsnId"
        class="monastery-item flex-grow overflow-visible mb-2 rounded shadow"
        @click="rowClick(monastery)"
      >
      <template #content>
        <h2 class="font-bold">{{monastery.name}}</h2>
        <p
          v-if="monastery.volumeNumber.length > 0"
          class="font-normal italic text-gray-500 text-xs"
        >
          Germania Sacra Band: {{monastery.volumeNumber[0]}}
        </p>
        <p class="mb-2"></p>

        <p class="text-xs text-primary-500 font-bold">Zeitraum</p>
        <p class="mb-2">{{monastery.orderTimeRange}}</p>

        <div class="flex">
          <div class="flex flex-col w-1/2">
            <p class="text-xs text-primary-500 font-bold">Ort</p>
            <p class="">{{monastery.places}}</p>
          </div>
          <div class="flex flex-col w-1/2">
            <p class="text-xs text-primary-500 font-bold">Patrozinium</p>
            <div class="flex">
              <div class="flex-shrink overflow-hidden flex flex-wrap mr-4">
                <div v-if="monastery.patrocinium && monastery.patrocinium !== ''">
                  <span>{{monastery.patrocinium}}</span>
                </div>
                <span v-else>-</span>
              </div>
            </div>
          </div>
        </div>
      </template>
      </Card>
    </div>

    <div class="w-full flex justify-center my-2">
      <Paginator
        :first="first"
        :rows="limit"
        :totalRecords="total"
        template="FirstPageLink PrevPageLink CurrentPageReport NextPageLink LastPageLink JumpToPageDropdown"
        currentPageReportTemplate="{currentPage} von {totalPages}"
        @page="onPageChange"
      ></Paginator>
    </div>
  </div>
</template>

<script>
export default {
  name: 'MonasteriesList',
  computed: {
    monasteries () {
      return this.$store.state.monasteriesList.map(item => ({
        ...item,
        orderTimeRange: item.orderTimeRange.join(' - '),
        places: item.locations.map(loc => loc.placeName).join(', '),
      }));
    },
    total () {
      return this.$store.state.monasteriesListTotalNumber;
    },
    limit () {
      return this.$store.state.monasteriesQuery.limit;
    },
    loading () {
      return this.$store.state.loadingList;
    },
    page: {
      get: function () {
        return this.$store.state.page;
      },
      set: function (page) {
        return page;
      },
    },
    first() {
      return this.limit * this.page;
    }
  },
  watch: {
    total () {
      this.$store.dispatch('setPage', 0);
    },
  },
  methods: {
    rowClick (item) {
      this.$router.push({ path: '/gsn/' + item.gsnId });
    },
    onPageChange ({ page, first}) {
      const offset = this.limit * page;
      this.$store.dispatch('getMonasteriesList', { offset });
      this.$store.dispatch('setPage', page);
    },
    getSpan ({ row, column, rowIndex, columnIndex }) {
      const rowSpan = 1;
      let colSpan = 1;

      if (columnIndex === 0) colSpan = 2;
      return [rowSpan, colSpan];
    },
  },
};
</script>
